#if !defined(_ADATA_DMACORE_H)
#define _ADATA_DMACORE_H

#include "platform.h"
#include "device.h"

/*
** -----------------------------------------------------------
** Client DMA functions
*/

/* Returns TRUE if on error */
extern os_boolean
ADMXRC_EnqueueDma(
  ADMXRC*         devCtx,
  ADMXRC_DMANODE* dmanode,
  os_boolean      must_start);

extern os_boolean
ADMXRC_SubmitDmaUsbd(
  ADMXRC*         devCtx,
  ADMXRC_DMANODE* dmanode,
  OS_USBD*        usbd,
  unsigned long   offset,
  unsigned long   max,
  os_uint32       local,
  unsigned long*  spanned);

extern os_boolean
ADMXRC_SubmitDmaUser(
  ADMXRC*         devCtx,
  ADMXRC_DMANODE* dmanode,
  void*           user,
  unsigned long   max,
  os_uint32       local,
  unsigned long*  spanned);

extern void
ADMXRC_CollectDma(
  ADMXRC*         devCtx,
  ADMXRC_DMANODE* dmanode);

/* Returns TRUE on error */
extern os_boolean
ADMXRC_ContinueDma(
  ADMXRC*         devCtx,
  ADMXRC_DMANODE* dmanode);

/* Returns TRUE if successfully cancelled */
extern os_boolean
ADMXRC_CancelDma(
  ADMXRC*         devCtx,
  ADMXRC_DMANODE* dmanode);

/*
** End of client DMA functions
** -----------------------------------------------------------
*/

/*
** Called by device open/close handler
*/
extern void
ADMXRC_CleanupDma(
  ADMXRC* devCtx);

/*
** Called as a result of a DMA interrupt
*/
extern void
ADMXRC_DmaCompleted(
  ADMXRC*       devCtx,
  unsigned char chan);

#endif
