/*
** ADM-XRC Series Driver
**
** (C) Copyright 2001-2004 Alpha Data
**
** drvparam.c - Retrieves the driver parameters and saves them in a globally
**              visible structure, for easy access.
**
** ----------------------------------------------------------------------------
*/

#include "device.h"
#include "drvparam.h"

void
initDriverParams(
  OS_DRIVER_OBJECT* pDrvObj)
{
  if (!os_get_driver_param(pDrvObj,
			   "PCIReadMultiple",
			   DriverParamType_uint32,
			   &driverParams.pciReadMultiple,
			   sizeof(os_uint32))) {
    driverParams.pciReadMultiple = 1;
  }
  
  if (os_get_driver_param(pDrvObj,
			  "PCIWriteAndInvalidate",
			  DriverParamType_uint32,
			  &driverParams.pciWriteAndInvalidate,
			  sizeof(os_uint32))) {
    driverParams.pciWriteAndInvalidate = 0;
  }

  if (os_get_driver_param(pDrvObj,
			  "PCI9656ErrataFix",
			  DriverParamType_uint32,
			  &driverParams.model.admxrc2.pci9656ErrataFix,
			  sizeof(os_uint32))) {
    driverParams.model.admxrc2.pci9656ErrataFix = 0;
  }

  if (os_get_driver_param(pDrvObj,
			  "MaxDmaDesc",
			  DriverParamType_uint32,
			  &driverParams.maxDmaDesc,
			  sizeof(os_uint32))) {
    driverParams.maxDmaDesc = ADMXRC_MAX_DMADESC;
  }

  if (os_get_driver_param(pDrvObj,
			  "MaxPlxDesc",
			  DriverParamType_uint32,
			  &driverParams.maxPlxDesc,
			  sizeof(os_uint32))) {
    driverParams.maxPlxDesc = ADMXRC_MAX_PLXDESC_PER_CHANNEL;
  }

  if (os_get_driver_param(pDrvObj,
			  "ADMXRC2PLUnlockFlash",
			  DriverParamType_uint32,
			  &driverParams.model.admxrc2pl.unlockFlash,
			  sizeof(os_uint32))) {
    driverParams.model.admxrc2pl.unlockFlash = 0;
  }
}
