#ifndef _ADATA_FLASH_H
#define _ADATA_FLASH_H

#include "device.h"

extern void
identifyFlash(
  DeviceContext* pDevCtx);

extern MethodResult
identifyFlashBlock(
  DeviceContext* pDevCtx,
  os_uint32      location,
  os_uint32*     blockStart,
  os_uint32*     blockSize,
  os_boolean*    isBootBlock);

extern MethodResult
eraseFlash(
  DeviceContext* pDevCtx,
  os_uint32      start,
  os_uint32      length);

extern MethodResult
readFlash(
  DeviceContext* pDevCtx,
  os_uint32      start,
  os_uint32      length,
  void*          buffer);

extern MethodResult
writeFlash(
  DeviceContext* pDevCtx,
  os_uint32      start,
  os_uint32      length,
  const void*    buffer);

#endif
