/*
** platform.h - Platform abstraction layer interface for Linux
**
** This header file pulls in the appropriate version of platform.h for
** the version of the Linux kernel being targetted.
*/

#ifndef _ADATA_PLATFORM_H
#define _ADATA_PLATFORM_H

#include <linux/version.h>

#if !defined(LINUX_VERSION_CODE)
# error Error: LINUX_VERSION_CODE is not defined!
#endif

#if (LINUX_VERSION_CODE >= 0x020600)
# include "platform-2.6.h"
#elif (LINUX_VERSION_CODE >= 0x020400)
# include "platform-2.4.h"
#else
# error Error: LINUX_VERSION_CODE indicates unsupported kernel version
#endif

#endif
