#ifndef _ADATA_XPLBRIDGE_H
#define _ADATA_XPLBRIDGE_H

#define NUM_XPLBRIDGE_DMA_CHANNEL (2)

/* Flags for NDL field of XPLDMADESC */
#define XPLDMADESC_LOCALSPACE	(0x0U << 0)
#define XPLDMADESC_PCISPACE		(0x1U << 0)
#define XPLDMADESC_ENDCHAIN		(0x1U << 1)
#define XPLDMADESC_INTERRUPT	(0x1U << 2)

/* Flags for SIZ field of XPLDMADESC */
#define XPLDMADESC_LOCALTOPCI	(0x1U << 31)
#define XPLDMADESC_PCITOLOCAL	(0x0U << 31)

/* An XPL bridge DMA descriptor */
typedef struct _XPLDMADESC {
  os_uint32     PAL;
  os_uint32     PAH;
  os_uint32     LA;
  os_uint32     SIZ;
  os_uint32     NDL;
  os_uint32     NDH;
  os_uint32     reserved1[2];
} os_declare_struct_packed XPLDMADESC;

typedef struct _XPLDMACON {
  os_uint32     PAL;
  os_uint32     PAH;
  os_uint32     LA;
  os_uint32     SIZ;
  os_uint32     NDL;
  os_uint32     NDH;
  os_uint32     CFG;
  os_uint32     CTL;
} os_declare_struct_packed XPLDMACON;

typedef struct _XPLBRIDGEREGS {
  os_uint32     LS0B;           /*  00 */
  os_uint32     LS0R;           /*  04 */
  os_uint32     LS0CFG;         /*  08 */
  os_uint32     reserved1[5];   /*  0C */
  os_uint32     LSTO;           /*  20 */
  os_uint32     LSTAT;          /*  24 */
  os_uint32     LCTL;           /*  28 */
  os_uint32     LERC;           /*  2C */
  os_uint32     LERA;           /*  30 */
  os_uint32     LICTL;          /*  34 */
  os_uint32     LISTAT;         /*  38 */
  os_uint32     reserved2[5];   /*  3C */
  os_uint32     PICTL;          /*  50 */
  os_uint32     PISTAT;         /*  54 */
  os_uint32     reserved4[10];  /*  58 */
  XPLDMACON     DMA[2];         /*  80 */
  os_uint32     LBRRD[4];       /*  C0 */
  os_uint32     LBRTM[4];       /*  D0 */
  os_uint32     LBRTV[4];       /*  E0 */
  os_uint32     LBRCSR;         /*  F0 */
  os_uint32     LBRA;           /*  F4 */
  os_uint32     reserved5[2];   /*  F8 */
} os_declare_struct_packed XPLBRIDGEREGS;

typedef struct _XPLSPACE1REGS {
  os_uint32     CLOCK;
  os_uint32     FLCTL;
  os_uint32     FLDATA;
  os_uint32     FPCTL;
  os_uint8      FPSMAP[4];
  os_uint32     FICTL;
  os_uint32     FISTAT;
  os_uint32     reserved1[1017];
} os_declare_struct_packed XPLSPACE1REGS;

typedef struct _XPSPACE1REGS {
  os_uint32     CLOCK;
  os_uint32     FLCTL;
  os_uint32     FLDATA;
  os_uint32     FPCTL;
  os_uint8      FPSMAP[4];
  os_uint32     FICTL;
  os_uint32     FISTAT;
  os_uint32     reserved1[1017];
} os_declare_struct_packed XPSPACE1REGS;

typedef struct _XPLCONFIGREV0 {
  os_uint16     version;
  os_uint16     boardType;
  os_uint32     modifications;
  os_uint32     refClockFreq;
  struct {
    os_uint8    order;
    os_uint8    width;
    os_uint16   typeMask;
  } os_declare_struct_packed bank[2];
  os_uint32     cardId;
  os_uint32     serialNumber;
  os_uint16     fpgaType;
  os_uint8      pcbRev;
  os_uint8      cpldRev;
} os_declare_struct_packed XPLCONFIGREV0;

typedef struct _XPCONFIGREV0 {
  os_uint16     version;
  os_uint16     boardType;
  os_uint32     modifications;
  os_uint32     refClockFreq;
  struct {
    os_uint8    order;
    os_uint8    reserved1;
  } os_declare_struct_packed zbt[4];
  struct {
    os_uint8    order;
    os_uint8    reserved1;
  } os_declare_struct_packed sdram[2];
  os_uint32     cardId;
  os_uint32     serialNumber;
  os_uint16     fpgaType;
  os_uint8      pcbRev;
  os_uint8      reserved;
} os_declare_struct_packed XPCONFIGREV0;

#endif
