/*
** ioctl.h - platform independent definitions for
** API-to-driver interface.
**
** NOTE: this file should not be included by applications.
**
** (C) Copyright 2000-2004 Alpha Data Parallel Systems Ltd.
*/

#if !defined(_ADATA_ADMXRC_IOCTL_H)
#define _ADATA_ADMXRC_IOCTL_H

#include <admxrc/status.h>
#include <admxrc/struct.h>
#include <admxrc2/flashinf.h>
#include <admxrc2/status.h>
#include <admxrc2/struct.h>
#include "ioctl_platform.h"

typedef enum _ADMXRC_KEY_IOCTL_CODES {
  ADMXRC_KEY_IOCTL_SETCLOCK = ADMXRC_KEY_STARTIOCTL,
  ADMXRC_KEY_IOCTL_OPENCARD,
  ADMXRC_KEY_IOCTL_GETCARDINFO,
  ADMXRC_KEY_IOCTL_DODMA,
  ADMXRC_KEY_IOCTL_LOADFPGA,
  ADMXRC_KEY_IOCTL_WRITEREG,
  ADMXRC_KEY_IOCTL_READREG,
  ADMXRC_KEY_IOCTL_GETCLOCKTYPE,
  ADMXRC_KEY_IOCTL_GETBASEADDRESS,
  ADMXRC_KEY_IOCTL_WAITFORINTERRUPT,
  ADMXRC_KEY_IOCTL_WRITE,
  ADMXRC_KEY_IOCTL_READ,
  ADMXRC_KEY_IOCTL_SETUPDMA,
  ADMXRC_KEY_IOCTL_UNSETUPDMA,
  ADMXRC_KEY_IOCTL_PROGRAMBYTES,
  ADMXRC_KEY_IOCTL_REGINTERRUPTEVENT,
  ADMXRC_KEY_IOCTL_UNREGINTERRUPTEVENT,
  ADMXRC_KEY_IOCTL_GETVERSIONINFO,
  ADMXRC_KEY_IOCTL_UNCONFIGUREFPGA,
  ADMXRC_KEY_IOCTL_CHECKFPGACONFIGURED,
  ADMXRC_KEY_IOCTL_MAPDIRECTMASTER,
  ADMXRC_KEY_IOCTL_SYNCDIRECTMASTER,
  ADMXRC_KEY_IOCTL_GETCARDINFO2,
  ADMXRC_KEY_IOCTL_GETBANKINFO,
  ADMXRC_KEY_IOCTL_OPENCARD2,
  ADMXRC_KEY_IOCTL_SETCLOCK2,
  ADMXRC_KEY_IOCTL_GETSPACEINFO,
  ADMXRC_KEY_IOCTL_OPENCARDBYINDEX,
  ADMXRC_KEY_IOCTL_READCONFIG,
  ADMXRC_KEY_IOCTL_WRITECONFIG,
  ADMXRC_KEY_IOCTL_DODMAIMMEDIATE,
  ADMXRC_KEY_IOCTL_LOADFPGADMA,
  ADMXRC_KEY_IOCTL_CANCELWAITFORINTERRUPT,
  ADMXRC_KEY_IOCTL_REGDMAEVENT,
  ADMXRC_KEY_IOCTL_GETFLASHINFO,
  ADMXRC_KEY_IOCTL_GETFLASHBLOCKINFO,
  ADMXRC_KEY_IOCTL_ERASEFLASH,
  ADMXRC_KEY_IOCTL_READFLASH,
  ADMXRC_KEY_IOCTL_WRITEFLASH,
  ADMXRC_KEY_IOCTL_GETSPACECONFIG,
  ADMXRC_KEY_IOCTL_SETSPACECONFIG,
  ADMXRC_KEY_IOCTL_DODMA2D,
  ADMXRC_KEY_IOCTL_DODMAIMMEDIATE2D
} ADMXRC_KEY_IOCTL_CODES;

#define ADMXRC_IOCTL_SETCLOCK              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SETCLOCK,            ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_OPENCARD              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_OPENCARD,            ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_LOADFPGA              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_LOADFPGA,            ADMXRC_IOCTLF_MASS_WRITE,     ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_WRITEREG              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WRITEREG,            ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_READREG               ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_READREG,             ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETCLOCKTYPE          ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETCLOCKTYPE,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETBASEADDRESS        ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETBASEADDRESS,      ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETCARDINFO           ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETCARDINFO,         ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_DODMA                 ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_DODMA,               ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_WAIT)
#define ADMXRC_IOCTL_WAITFORINTERRUPT      ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WAITFORINTERRUPT,    ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_WRITE                 ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WRITE,               ADMXRC_IOCTLF_MASS_WRITE,     ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_READ                  ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_READ,                ADMXRC_IOCTLF_MASS_READ,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_SETUPDMA              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SETUPDMA,            ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_UNSETUPDMA            ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_UNSETUPDMA,          ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_PROGRAMBYTES          ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_PROGRAMBYTES,        ADMXRC_IOCTLF_MASS_READWRITE, ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_REGINTERRUPTEVENT     ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_REGINTERRUPTEVENT,   ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_UNREGINTERRUPTEVENT   ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_UNREGINTERRUPTEVENT, ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETVERSIONINFO        ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETVERSIONINFO,      ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_UNCONFIGUREFPGA       ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_UNCONFIGUREFPGA,     ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_CHECKFPGACONFIGURED   ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_CHECKFPGACONFIGURED, ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_MAPDIRECTMASTER       ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_MAPDIRECTMASTER,     ADMXRC_IOCTLF_MASS_READ,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_SYNCDIRECTMASTER      ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SYNCDIRECTMASTER,    ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETCARDINFO2          ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETCARDINFO2,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETBANKINFO           ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETBANKINFO,         ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_OPENCARD2             ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_OPENCARD2,           ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_SETCLOCK2             ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SETCLOCK2,           ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETSPACEINFO          ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETSPACEINFO,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_OPENCARDBYINDEX       ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_OPENCARDBYINDEX,     ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_READCONFIG            ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_READCONFIG,          ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_WRITECONFIG           ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WRITECONFIG,         ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_DODMAIMMEDIATE        ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_DODMAIMMEDIATE,      ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_WAIT)
#define ADMXRC_IOCTL_LOADFPGADMA           ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_LOADFPGADMA,         ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_WAIT)
#define ADMXRC_IOCTL_CANCELWAITFORINTERRUPT ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_CANCELWAITFORINTERRUPT, ADMXRC_IOCTLF_MASS_NONE, ADMXRC_IOCTLF_NOWAIT)
#define  ADMXRC_IOCTL_REGDMAEVENT          ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_REG_DMAEVENT,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define  ADMXRC_IOCTL_GETFLASHINFO         ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETFLASHINFO,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define  ADMXRC_IOCTL_GETFLASHBLOCKINFO    ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETFLASHBLOCKINFO,   ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define  ADMXRC_IOCTL_ERASEFLASH           ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_ERASEFLASH,          ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define  ADMXRC_IOCTL_READFLASH            ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_READFLASH,           ADMXRC_IOCTLF_MASS_READ,      ADMXRC_IOCTLF_NOWAIT)
#define  ADMXRC_IOCTL_WRITEFLASH           ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WRITEFLASH,          ADMXRC_IOCTLF_MASS_WRITE,     ADMXRC_IOCTLF_NOWAIT)
#define  ADMXRC_IOCTL_GETSPACECONFIG       ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETSPACECONFIG,      ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define  ADMXRC_IOCTL_SETSPACECONFIG       ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SETSPACECONFIG,      ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_DODMA2D               ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_DODMA2D,             ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_WAIT)
#define ADMXRC_IOCTL_DODMAIMMEDIATE2D      ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_DODMAIMMEDIATE2D,    ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_WAIT)

/* Additional flags that can be added by driver wrapper */
#define ADMXRC_DMAFLAG_TIMEOUT (0x1 << 31)

typedef union _ADMXRC_IOCTLS_DODMA { 
  struct {
    ADMXRC2_DMADESC dmadesc;
    unsigned long   offset;
    unsigned long   length;
    unsigned long   local;
    unsigned long   direction;
    unsigned long   channel;
    unsigned long   mode;
    unsigned long   flags;
    unsigned long   timeout;
  } in;
} ADMXRC_IOCTLS_DODMA;

typedef union _ADMXRC_IOCTLS_DODMA2D { 
  struct {
    ADMXRC2_DMADESC dmadesc;
    unsigned long   offset;
    unsigned long   length;
    unsigned long   local;
    unsigned long   width;
    unsigned long   skip;
    unsigned long   local_skip;
    unsigned long   direction;
    unsigned long   channel;
    unsigned long   mode;
    unsigned long   flags;
    unsigned long   timeout;
  } in;
} ADMXRC_IOCTLS_DODMA2D;

typedef union _ADMXRC_IOCTLS_DODMAIMMEDIATE {
  struct {
    void*         buffer;
    unsigned long length;
    unsigned long local;
    unsigned long direction;
    unsigned long channel;
    unsigned long mode;
    unsigned long flags;
    unsigned long timeout;
  } in;
} ADMXRC_IOCTLS_DODMAIMMEDIATE;

typedef union _ADMXRC_IOCTLS_DODMAIMMEDIATE2D {
  struct {
    void*         buffer;
    unsigned long length;
    unsigned long local;
    unsigned long width;
    unsigned long skip;
    unsigned long local_skip;
    unsigned long direction;
    unsigned long channel;
    unsigned long mode;
    unsigned long flags;
    unsigned long timeout;
  } in;
} ADMXRC_IOCTLS_DODMAIMMEDIATE2D;

#define ADMXRC_IOCTLS_ERASEFLASH_SIGNATURE1 (0x0516fab8U)
#define ADMXRC_IOCTLS_ERASEFLASH_SIGNATURE2 (0x694371bcU)

typedef union _ADMXRC_IOCTLS_ERASEFLASH {
  struct {
    unsigned long signature1;
    unsigned long start;
    unsigned long length;
    unsigned long signature2;
  } in;
} ADMXRC_IOCTLS_ERASEFLASH;

typedef union _ADMXRC_IOCTLS_GETBANKINFO {
  struct {
    unsigned long     index;
  } in;
  struct {
    ADMXRC2_BANK_INFO info;
  } out;
} ADMXRC_IOCTLS_GETBANKINFO;

typedef union _ADMXRC_IOCTLS_GETCARDINFO {
  struct {
    ADMXRC_CARD_INFO info;
  } out;
} ADMXRC_IOCTLS_GETCARDINFO;

typedef union _ADMXRC_IOCTLS_GETCARDINFO2 {
  struct {
    ADMXRC2_CARD_INFO info;
  } out;
} ADMXRC_IOCTLS_GETCARDINFO2;

typedef union _ADMXRC_IOCTLS_GETCLOCKTYPE {
  struct {
    unsigned long type;
  } out;
} ADMXRC_IOCTLS_GETCLOCKTYPE;

typedef union _ADMXRC_IOCTLS_GETFLASHINFO {
  struct {
    ADMXRC2_FLASH_INFO info;
  } out;
} ADMXRC_IOCTLS_GETFLASHINFO;

typedef union _ADMXRC_IOCTLS_GETFLASHBLOCKINFO {
  struct {
    unsigned long           location;
  } in;
  struct {
    ADMXRC2_FLASHBLOCK_INFO info;
  } out;
} ADMXRC_IOCTLS_GETFLASHBLOCKINFO;

typedef union _ADMXRC_IOCTLS_GETSPACECONFIG {
  struct {
    unsigned int  space_index;
  } in;
  struct {
    unsigned long flags;
  } out;
} ADMXRC_IOCTLS_GETSPACECONFIG;

typedef union _ADMXRC_IOCTLS_GETSPACEINFO {
  struct {
    unsigned long      index;
  } in;
  struct {
    ADMXRC2_SPACE_INFO info;
  } out;
} ADMXRC_IOCTLS_GETSPACEINFO;

typedef union _ADMXRC_IOCTLS_GETVERSIONINFO {
  struct {
    unsigned char major;
    unsigned char minor;
  } out;
} ADMXRC_IOCTLS_GETVERSIONINFO;

typedef union _ADMXRC_IOCTLS_LOADFPGADMA {
  struct {
    unsigned long channel;
    unsigned long flags;
    void*         buffer;
    unsigned long length;
  } in;
} ADMXRC_IOCTLS_LOADFPGADMA;

typedef union _ADMXRC_IOCTLS_MAPDIRECTMASTER {
  struct {
    ADMXRC2_DMADESC dmadesc;
    unsigned long   offset;
    unsigned long   length;
    unsigned long   maxpage;
  } in;
  struct {
    unsigned long   pagelen;
    unsigned long   pagebits;
    unsigned long   pagespan;
    unsigned long   bytespan;
    unsigned long   initoffs;
  } out;
} ADMXRC_IOCTLS_MAPDIRECTMASTER;

typedef union _ADMXRC_IOCTLS_OPENCARD {
  struct {
    unsigned long card_id;
  } in;
} ADMXRC_IOCTLS_OPENCARD;

typedef union _ADMXRC_IOCTLS_OPENCARD2 {
  struct {
    unsigned long card_id;
  } in;
} ADMXRC_IOCTLS_OPENCARD2;

typedef union _ADMXRC_IOCTLS_PROGRAMBYTES {
  struct {
    unsigned long length;
  } in;
} ADMXRC_IOCTLS_PROGRAMBYTES;

typedef union _ADMXRC_IOCTLS_READ {
  struct {
    unsigned long width;
    unsigned long local;
    unsigned long flags;
  } in;
} ADMXRC_IOCTLS_READ;

typedef union _ADMXRC_IOCTLS_READCONFIG {
  struct {
    unsigned long index;
  } in;
  struct {
    unsigned long value;
  } out;
} ADMXRC_IOCTLS_READCONFIG;

typedef union _ADMXRC_IOCTLS_READFLASH {
  struct {
    unsigned long start;
    unsigned long length;
  } in;
} ADMXRC_IOCTLS_READFLASH;

typedef union _ADMXRC_IOCTLS_READREG {
  struct {
    unsigned char index;
  } in;
  struct {
    unsigned char value;
  } out;
} ADMXRC_IOCTLS_READREG;

#if 0
typedef union _ADMXRC_IOCTLS_REGDMAEVENT {
  struct {
    HANDLE       event;
    unsigned int channel;
  } in;
} ADMXRC_IOCTLS_REGDMAEVENT;
#endif

typedef union _ADMXRC_IOCTLS_REGINTERRUPTEVENT {
  struct {
    os_event event;
  } in;
} ADMXRC_IOCTLS_REGINTERRUPTEVENT;

typedef union _ADMXRC_IOCTLS_SETCLOCK {
  struct {
    unsigned long clockword;
  } in;
} ADMXRC_IOCTLS_SETCLOCK;

typedef union _ADMXRC_IOCTLS_SETCLOCK2 {
  struct {
    unsigned long clock_index;
    unsigned long freq;
  } in;
  struct {
    unsigned long actual;
  } out;
} ADMXRC_IOCTLS_SETCLOCK2;

typedef union _ADMXRC_IOCTLS_SETSPACECONFIG {
  struct {
    unsigned int  space_index;
    unsigned long flags;
  } in;
} ADMXRC_IOCTLS_SETSPACECONFIG;

typedef union _ADMXRC_IOCTLS_SETUPDMA {
  struct {
    void*           buffer;
    unsigned long   size;
    unsigned long   flags;
  } in;
  struct {
    ADMXRC2_DMADESC dmadesc;
  } out;
} ADMXRC_IOCTLS_SETUPDMA;

typedef union _ADMXRC_IOCTLS_SYNCDIRECTMASTER {
  struct {
    ADMXRC2_DMADESC dmadesc;
    unsigned long   offset;
    unsigned long   length;
    unsigned long   syncmode;
  } in;
} ADMXRC_IOCTLS_SYNCDIRECTMASTER;

typedef union _ADMXRC_IOCTLS_UNREGINTERRUPTEVENT {
  struct {
    os_event event;
  } in;
} ADMXRC_IOCTLS_UNREGINTERRUPTEVENT;

typedef union _ADMXRC_IOCTLS_UNSETUPDMA {
  struct {
    ADMXRC2_DMADESC dmadesc;
  } in;
} ADMXRC_IOCTLS_UNSETUPDMA;

/* Additional flags that can be added by driver wrapper */
#define ADMXRC_INTWAIT_TIMEOUT (0x1 << 31)

typedef union _ADMXRC_IOCTLS_WAITFORINTERRUPT {
  struct {
    unsigned long timeout_us;
    unsigned long flags;
  } in;
  struct {
    unsigned long remaining_us;
    int           expired;
  } out;
} ADMXRC_IOCTLS_WAITFORINTERRUPT;

typedef union _ADMXRC_IOCTLS_WRITE {
  struct {
    unsigned long width;
    unsigned long local;
    unsigned long flags;
  } in;
} ADMXRC_IOCTLS_WRITE;

#define ADMXRC_IOCTLS_WRITECONFIG_SIGNATURE1 (0x587d3f31U)
#define ADMXRC_IOCTLS_WRITECONFIG_SIGNATURE2 (0x043a749fU)

typedef union _ADMXRC_IOCTLS_WRITECONFIG {
  struct {
    unsigned long signature1;
    unsigned long index;
    unsigned long value;
    unsigned long signature2;
  } in;
} ADMXRC_IOCTLS_WRITECONFIG;

#define ADMXRC_IOCTLS_WRITEFLASH_SIGNATURE1 (0xd4b39c05U)
#define ADMXRC_IOCTLS_WRITEFLASH_SIGNATURE2 (0x6507e128U)

typedef union _ADMXRC_IOCTLS_WRITEFLASH {
  struct {
    unsigned long signature1;
    unsigned long start;
    unsigned long length;
    unsigned long signature2;
  } in;
} ADMXRC_IOCTLS_WRITEFLASH;

typedef union _ADMXRC_IOCTLS_WRITEREG {
  struct {
    unsigned char index;
    unsigned char value;
  } in;
} ADMXRC_IOCTLS_WRITEREG;

#endif

