/*
** ioctl_platform.h - platform dependent definitions for
** API-to-driver interface.
**
** NOTE: this file should not be included by applications.
**
** (C) Copyright 2000-2004 Alpha Data Parallel Systems Ltd.
*/

#if !defined(_ADATA_IOCTL_PLATFORM_H)
#define _ADATA_IOCTL_PLATFORM_H

/* This is a 'Linux thing' */
#define ADMXRC_IOCTL_TYPE                  (150)

/* Macro to generate an IOCTL code as passed to 2nd argument of ioctl() */
#define ADMXRC_MAKE_IOCTL(key, mass, wait) _IO(ADMXRC_IOCTL_TYPE, ((key) << 3) | (mass << 1) | (wait))

/* Macros for getting the fields of an IOCTL code */
#define ADMXRC_GET_IOCTLF_WAIT(code)       (((code) >> 0) & 0x1U)
#define ADMXRC_GET_IOCTLF_MASS(code)       (((code) >> 1) & 0x3U)
#define ADMXRC_GET_IOCTL_KEY(code)         (((code) >> 3) & 0xffU)

/* Values for 'wait' parameter of ADMXRC_MAKE_IOCTL */
#define ADMXRC_IOCTLF_NOWAIT               (0x0)
#define ADMXRC_IOCTLF_WAIT                 (0x1)

/* Values for 'mass' parameter of ADMXRC_MAKE_IOCTL */
#define ADMXRC_IOCTLF_MASS_NONE            (0x0) /* no mass buffer required */
#define ADMXRC_IOCTLF_MASS_READ            (0x1) /* mass buffer copied TO user space   */
#define ADMXRC_IOCTLF_MASS_WRITE           (0x2) /* mass buffer copied FROM user space */
#define ADMXRC_IOCTLF_MASS_READWRITE       (0x3) /* mass buffer copied FROM and then copied TO user space */

/* Value at which ADMXRC_KEY_IOCTL_xxxx enumerated type should begin */
#define ADMXRC_KEY_STARTIOCTL              (0x0) /* Allowable value for Linux */

typedef struct _ADMXRC_IOCTL_PARAMS {
  struct {
    void*         lpBuffer;
    unsigned long nSize;
  } in;
  struct {
    unsigned long nSize;
    void*         lpBuffer;
  } out;
  struct {
    void*         lpBuffer;
    unsigned long nSize;
  } mass;
} ADMXRC_IOCTL_PARAMS;

#endif
