#if !defined(_ADATA_PLATFORM2_H)
#define _ADATA_PLATFORM2_H

/*
** platform2.h - abstraction layer for ADM-XRC API library
**
** (C) Copyright 2002-2004 Alpha Data Parallel Systems Ltd.
*/

#if !defined(TRUE)
#   define TRUE (1)
#endif

#if !defined(FALSE)
#   define FALSE (0)
#endif

typedef void* os_event; /* Parameters of this type are always ignored in the Linux API */
typedef int   os_boolean;

#include <math.h> 
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <fcntl.h>

#include <asm/page.h>

/*
#include <linux/ioctl.h>
#include <linux/mman.h>
*/

#include "ioctl.h"

typedef int (_ADMXRC2_enum_fn)(int index, ADMXRC2_HANDLE handle, void* context);

extern os_boolean
_ADMXRC2_IoCtlNoWait(
  ADMXRC2_HANDLE  hDevice,        /* device handle (file pointer)             */
  unsigned long   IoControlCode,  /* IOCTL code                               */
  void*	          lpInBuffer,     /* pointer to buffer to supply input data   */
  unsigned long	  nInBufferSize,  /* size of input buffer                     */
  void*           lpOutBuffer,    /* pointer to buffer to receive output data */
  unsigned long	  nOutBufferSize, /* size of output buffer                    */
  ADMXRC2_STATUS* status);

extern os_boolean
_ADMXRC2_IoCtlNoWaitMass(
  ADMXRC2_HANDLE  hDevice,        /* device handle (file pointer)             */
  unsigned long   IoControlCode,  /* IOCTL code                               */
  void*	          lpInBuffer,     /* pointer to buffer to supply input data   */
  unsigned long	  nInBufferSize,  /* size of input buffer                     */
  void*           lpOutBuffer,    /* pointer to buffer to receive output data */
  unsigned long	  nOutBufferSize, /* size of output buffer                    */
  void*           lpMassBuffer,   /* pointer to buffer to receive output data */
  unsigned long	  nMassSize,      /* size of output buffer                    */
  int             nMassMode,      /* 0x1 => to user space, 0x2 => from user space */
  ADMXRC2_STATUS* status);

#define _ADMXRC2_IoCtlWait(a,b,c,d,e,f,g,h)           _ADMXRC2_IoCtlNoWait(a,b,c,d,e,f,h)
#define _ADMXRC2_IoCtlWaitMass(a,b,c,d,e,f,g,h,i,j,k) _ADMXRC2_IoCtlNoWaitMass(a,b,c,d,e,f,g,h,i,k)

extern void
_ADMXRC2_strlwr(
  char *a);

extern ADMXRC2_STATUS
_ADMXRC2_handleError(
  const char*    fn,
  ADMXRC2_STATUS status);

extern ADMXRC2_STATUS
_ADMXRC2_Close(
  ADMXRC2_HANDLE card);

extern void
_ADMXRC2_Enumerate(
  _ADMXRC2_enum_fn fn,
  void*            context);

extern ADMXRC2_STATUS
_ADMXRC2_MapToUserSpace(
  ADMXRC2_HANDLE card);

extern ADMXRC2_STATUS
_ADMXRC2_OpenByIndex(
  int             index,
  ADMXRC2_HANDLE* card);

extern void*
_ADMXRC2_PageMalloc(
  unsigned long n);

extern void
_ADMXRC2_PageFree(
  void* p);

extern ADMXRC2_ERROR_HANDLER _ADMXRC2_errorHandler;

#endif
